#!/usr/bin/python
# -*- coding: UTF-8 -*-
# 并发下载检测文件

import threading
import urllib2
import os
import socket

download_path = os.path.abspath(os.path.join(os.path.dirname(__file__), "..")) + "/app/"


class downloadThread(threading.Thread):
    def __init__(self, threadID, name, url):
        threading.Thread.__init__(self)
        self.threadID = threadID
        self.name = name
        self.url = url
        self.flag = False
        self.result = ""

    def run(self):
        print ("Starting " + self.name)
        print (self.url)

        request = urllib2.Request(self.url)
        request.add_header("Content-Type","text/plain")

        f = urllib2.urlopen(request).read()
        if len(f) < 20 or f.find("# -*- coding: utf-8 -*-") == -1:
            self.flag = False
            self.result = "下拉脚本内容异常"
        else:
            with open(download_path + self.name, "wb") as code:
                code.write(f)
            self.flag = True
            self.result = "下拉脚本成功"

def isNetOK(testserver):
    s=socket.socket()
    s.settimeout(3)
    try:
        status = s.connect_ex(testserver)
        if status == 0:
            s.close()
            return True
        else:
            return False
    except Exception as e:
        return False


def downloadTask(task_array, cp):
    if len(task_array) > 0:
        url = cp.get("server", "download")
        serverUrl = cp.get("server", "host") + cp.get("server", "sdownload")
        threads = []
        # 创建新线程
        index = 0
        netStatus = isNetOK(('myqcloud.com',443))
        for t in task_array:
            index += 1
            fileName = str(t['scriptName'])
            version = str(t['version'])
            fullUrl = url + fileName.replace(".py", "") + '/' + version + ".py"
            if not netStatus:
                fullUrl =  serverUrl + fileName + '/' + version
            thread1 = downloadThread(index, fileName, fullUrl)
            thread1.start()
            threads.append(thread1)

        # 等待所有线程完成
        for t in threads:
            t.join()
        print("Download Thread Execute Finished..")
        result = []
        for t in threads:
            result.append(t)
        return result
    else:

        print("Task Array is Null...")
        return []
